import subprocess
import requests
import sys
from flask import jsonify
from abc import ABC,abstractmethod

class Cyberware(ABC):
	# I'll expand this as necessary
	urlBase = "http://localhost:5000/"
	ENDPOINTS = {
			"heartrate":urlBase+"api/vitals/heartrate",
			"steps":urlBase+"api/vitals/steps",
			"bodytemp":urlBase+"api/vitals/bodytemp",
			"oxygen":urlBase+"api/vitals/oxygen",
			"battery":urlBase+"api/vitals/battery",
			"add":urlBase+"api/cyberware/add",
			"remove":urlBase+"api/cyberware/remove"
			}

	def sendValue(self, url, jsonRequest):
		try:
			oldJson = json.loads(jsonRequest)
			uuidJson = {'uuid': self.uuid}
			oldJson.update(uuidJson)
			jsonWithUuid = json.dumps(oldJson)

			request = requests.post(url, json=jsonWithUuid)

		except:
			print(self.apiFailMsg)
			return 2 # 2 = No API contact.

		if request.status_code > 399:
			return 3 # 3 = API refused request.

		if request.status_code > 299:
			return 4 # 4 = API encountered an internal error.

		return 0 # 0 = Success

	@property
	@abstractmethod
	def uuid(self):
		pass

	@abstractmethod
	def sendAll(self):
		pass

	@abstractmethod
	def connectCyberware(self):
		pass

	@abstractmethod
	def disconnectCyberware(self):
		pass
