from infinitime import Infinitime
from aggregatorRecv import AggregatorRecv
import time
import configparser
import json

config = configparser.ConfigParser()
config.read('config.ini')

pinetimeEnabled = config.getboolean('enabled','Infinitime')
aggregatorEnabled = config.getboolean('enabled', 'AggregatorRecv')

enabled = []

if(pinetimeEnabled):
	pinetime = Infinitime()
	capabilities = json.loads(config.get('infinitime','capabilities'))
	enabled.append(pinetime)
	pinetime.connectCyberware()

if(aggregatorEnabled):
	aggregator = AggregatorRecv()
	capabilities = json.loads(config.get('aggregatorRecv','capabilities'))
	enabled.append(aggregator)
	aggregator.connectCyberware()

continueFlag = True

#while continueFlag:
#	try:
#		if(pinetimeEnabled):
#			pinetime.sendHeartrate()
#			pinetime.sendSteps()
#			pinetime.sendHeartrate()
#
#		time.sleep(1)
#	except KeyboardInterrupt:
#		print("Stopping vitalsd")
#		continueFlag = False
#
#if(pinetimeEnabled):
#	pinetime.disconnectCyberware()

while continueFlag:
	try:
		for c in enabled:
			c.sendAll()
		time.sleep(1)
	except KeyboardInterrupt:
		print("Stopping vitalsd")
		continueFlag = False

for c in enabled:
	c.disconnectCyberware()
